part of hud;


class Authenticator {
  
  String server;
  
  Authenticator(String server) {
    this.server = server;
  }
  
  
  Map user = {};
  
  
  /// Checks if a user is logged in or not by calling the authentication server.
  /// 
  bool checkUser({bool prompt}) {
    // Check user status with the server
    httpGet('$server/_x/identity/status', null, (r) {
      
      if (r is HttpRequest && r.status == 200) {
        user = C.JSON.decode(r.response);
        if (user['id'] == 'Guest')
          // Came back as 'Guest', which means we aren't logged in.
          // We need to log in, show the User Page
          if (prompt != null && prompt == true) {
            _showUserPrompt();
            return false;
          }
        else
          // An identity came back other than Guest.
          // Already logged in, show the Clock Page.
          return true;
      } else {
        // Error! Status wasn't 200, or the request failed all together.
        // TODO: Differentiate, possibly show error code, multiple handlers, etc.
        HttpErrorPrompt.show();
      }
    });
  }

  
  showUserInfoPrompt() {
    Prompt p = new Prompt();
      
    p..title = 'User information'
      ..body = ''' <div class='loading-spinner'></div> '''
      ..getMenu().addMenuObject(new PopupButton('thumbs-ok', 'Okay, all done!', 
          (PopupButton b) {
          Prompt.hide(p);
      }))
      
      ..show();
    
    httpReq('$server/_x/identity/status').then((HttpRequest r) {
      Map response = C.JSON.decode(r.response);
      String name = response['user-name'];
      String time = response['time'];
      String sessions = response['sessions'];

      if (name == 'Guest')
        p.body = 'You are not logged on right now. Actions taken are done as \'Guest\'';
      else 
        p.body = 'Name: $name, Session: $sessions';
      
      p.show();
    }, onError: (r) {
      HttpErrorPrompt.show();
    });
    
  }
  
  
  Prompt u;
  
  _showUserPrompt() {
       u = new Prompt()
               ..title = 'Please log in.'
               ..body = '''Enter a username and password:<br>
                    <input id="user-id" type="text">
                    <input id="user-pass" type="password">'''
               ..getMenu().addMenuObject(new PopupButton('thumbs-ok', 'Okay!', (PopupButton p) {
                   _tryUserLogin();
               })).addMenuObject(new PopupButton('times-outline', 'Log out', (PopupButton p) {
                   // TODO: Logout
               }))
               ..show();
   }

   
   _tryUserLogin() {
       Map data = new Map<String, String>();
       InputElement id = querySelector('#user-id');
       data['username'] = id.value;
       InputElement ps = querySelector('#user-pass');
       data['password'] = ps.value;
       new Container.fromSelector('.prompt-body').showAsLoading();
       httpReq('$server/_x/identity/authorize', data: data)
           .then((r) {
           // Login sucessful
           if (r.status == 202) {
               user = C.JSON.decode(r.responseText);
               bool closed = false;
               Prompt.hide(u);
               new Notifications('You have successfully logged in.', showTime: true);
           }
       }, onError: (r) {
           if (!(r is HttpRequest)) {
               // Login username/password incorrect
               if (r.target.status == 406) {
                   new Prompt()
                           ..title = 'Unable to log in!'
                           ..body = '''
                              The username and/or password entered was incorrect. 
                              Enter a username and password:
                              <br><input id="user-id" type="text" value=''' + data['username'] + '''><input id="user-pass" type="password">'''
                           ..getMenu().addMenuObject(new PopupButton('thumbs-ok', 'Okay!', (PopupButton p) {
                              _tryUserLogin();

                           })).addMenuObject(new PopupButton('key-outline', 'Forgot password?', (PopupButton p) {
                               // _forgotPassword();
                           }))
                           ..show();
               } else HttpErrorPrompt.show();
           }
       });

   }

}