part of hud;


///
///
/// The header handles the page title and icon.
///
///


class Header {
  
  
  String page_title;
  String page_icon;
  String page_menu;
  
  Header(String page_title_selector, String page_icon_selector) {
    Uuid u = new Uuid();
    String uuid = u.v4();
    
    page_title = page_title_selector;
    page_icon = page_icon_selector;
    
    querySelector(page_icon).insertAdjacentElement('beforeEnd', new ImageElement());
    
    querySelector(page_icon)
        ..onMouseEnter.listen(_over)
        ..onMouseLeave.listen(_leave);
  }
  
  
  change({String text, String icon, String color}) {
    if (text != null)
      querySelector(page_title).innerHtml = text;
    if (icon != null)
      querySelector('$page_icon>img').setAttribute('src', Icon.getIconPath(icon));
    if (color != null)
      querySelector(page_icon).style.backgroundColor = color;
  }
  

  //
  // HANDLERS
  
  // Initialize listeners and such
  static void initialize() {

  }

  bool _leaving = false;
  bool _started = false;

  void _over(Event e) {
    // Don't start if currently 'leaving'
    if (!_leaving) {
      // Animate the icon
      new ElementAnimation(querySelector('$page_icon>img'))
          ..duration = 1000
          ..properties = {
            'opacity': 1,
            'margin-top': -20
          }
          ..run();
      // Note started state
      _started = true;
    }
  }

  void _leave(Event e) {
    // Don't leave is already leaving, or if already started
    if (!_leaving && _started) {
      _leaving = true;
      // Animate the icon
      new ElementAnimation(querySelector('$page_icon>img'))
          ..duration = 3000
          ..properties = {
            'opacity': 0.4,
            'margin-top': 0
          }
          ..run();
      // Reset the booleans after 2 seconds
      new Timer(new Duration(seconds: 2), () {
        _leaving = false;
        _started = false;
      });
    }
  }

  
  
}
