part of hud;


///
///
/// notifications display a 'growl-like' window near the bottom
/// of the window.
///
///

class Notifications {

    static DateFormat f = new DateFormat.yMd().add_Hm();
    
    //
    // HANDLERS

    // Initialize listeners and such
    static void initialize() {
        window.onResize.listen(resize);

        querySelector('#notifications')
                ..onMouseEnter.listen(enter)
                ..onMouseLeave.listen(leave);

    }

    // Show all previous notifications on enter
    static void enter(Event e) {
        for (Element el in querySelector('#notifications').children) {
            el.style.display = 'block';
            el.style.opacity = '1.0';
        }
    }

    // ...and hide them on mouse leave
    static void leave(Event e) {
        for (Element el in querySelector('#notifications').children) {
            if (el.attributes.containsKey('timedout')) el.style.display = 'none';
        }
    }


    // notify the user when the window gets small
    static bool size_notify = true;

    static void resize(Event e) {
        if (window.innerWidth < 700) {

            if (size_notify) {
                size_notify = false;
                new Notifications('<em>Woah!</em> The window is getting cramped. ' + 'To see all the content available, resize the window to be larger.');
            }
        } else if (window.innerWidth > 1000) {
            size_notify = true;
        }
    }

    
    // new notifications will make an entry in the notification bar
    Notifications(String text, {bool showTime}) {

        if (showTime == null)
            showTime = false;
        
        // detect duplicated
        if (querySelector('#notifications').children.length > 0) 
          if (querySelector('#notifications').children[0].innerHtml == text) {
            querySelector('#notifications').children[0].remove();
        }

        // make a new Div
        DivElement e = new DivElement()
          ..innerHtml = (showTime == true ? f.format(new DateTime.now()) + ": $text" : text);

        // insert it in the notifications div
        querySelector('#notifications').insertAdjacentElement('afterBegin', e);

        // animate it
        var a = new ElementAnimation(e)
                ..duration = 2000
                ..properties = {
                    'opacity': 0
                };

        new Timer(new Duration(seconds: 3), () => a.run());

        new Timer(new Duration(seconds: 5), () {
            e.style.display = 'none';
            e.setAttribute('timedout', 'true');
        });

    }

}
