part of hud;



// Default prompts

Prompt HttpErrorPrompt = new Prompt()
    ..title = 'Oh no!'
    ..body = '''
        We were unable to talk with the authentication server. 
        Perhaps it is temporarily down, or your internet connection is unstable. '''
    ..getMenu().addMenuObject(new PopupButton('refresh-outline', 'Try again.', 
        (PopupButton p) {
        window.location.assign(window.location.href);
    }));





class Prompt {

  //
  // HANDLERS

  // Initialize listeners and such
  static void initialize() {

  }

  static List<Prompt> openPrompts = new List<Prompt>();
  
  static hide(Prompt p) {
    openPrompts.remove(p);
    if (openPrompts.isEmpty) {
      querySelector('#shade').style.display = 'none';
      querySelector('#prompts').style.display = 'none';
    } else
      openPrompts[0].show();
  }

  static hideAll() {
    querySelector('#shade').style.display = 'none';
    querySelector('#prompts').style.display = 'none';
  }


  //
  // INSTANCE

  String _id;
  String _html;

  Prompt() {
    _id = new Uuid().v4();
    _m = new Menu(_id, '#prompt-menu-$_id');
  }

  String title;
  String body;
  Menu _m;

  show() {
    _shade();
    _html = '''
      <div id='prompt-title-$_id' class='prompt-title'> </div>
      <div id='prompt-body-$_id' class='prompt-body'>   </div>
      <div id='prompt-menu-$_id' class='prompt-menu'>   </div>
    ''';
    querySelector('#prompts').setInnerHtml(_html, treeSanitizer: allHtml);
    querySelector('#prompt-title-$_id').setInnerHtml(title, treeSanitizer: allHtml);
    querySelector('#prompt-body-$_id').setInnerHtml(body, treeSanitizer: allHtml);
    _m.build();
    
    if (!openPrompts.contains(this))
      openPrompts.insert(0, this);
  }

  _shade() {
    querySelector('#shade').style.display = 'block';
    querySelector('#prompts').style.display = 'block';
  }

  Menu getMenu() {
    return _m;
  }

}
