part of hud;


///
///
/// Tooltips pop up info on mouse over
///
///

class Tooltip {

  static HashSet<Element> registered = new HashSet<Element>();
    
  //
  // HANDLERS
    
  // Initialize listeners and such
  static void initialize() {

  }
  
  static _mutation(List<MutationRecord> mutations, MutationObserver observer) {
    for (Element e in querySelectorAll('.tooltip')) {
      if (!registered.contains(e)) {
        e..onMouseEnter.listen(_enter)
          ..onMouseLeave.listen(_leave);
        registered.add(e);
      }
    }
  }

  /// Handle clicks
  static void _enter(Event e) {
     
      // Grab the target
      Element el = e.target;

      if (el.style.display == 'none')
          return;
      
      if (el.getAttribute("tooltip") != null) {
          // Get the tooltip string from the target
          String tooltip = el.getAttribute("tooltip");

          // Get the tooltip container for DOM manipulation
          Element container = querySelector('#tooltips');

          // Fixes some 'rending errors' in some cases
          container
              ..style.top = '0'
              ..style.left = '0';
          
          // TODO: fix horizontal scroll bug
          container
              ..style.display = 'inline'
              ..innerHtml = tooltip
              ..style.top = (el.offsetTop + el.offsetParent.offsetTop + el.offsetHeight + container.offsetHeight + 20 < window.innerHeight ? 
                      (el.offsetTop + el.offsetParent.offsetTop + el.offsetHeight + 20).toString() + 'px' : (el.offsetParent.offsetTop - el.offsetTop - container.offsetHeight - 20).toString() + 'px')
              ..style.left = (el.offsetLeft + el.offsetParent.offsetLeft + (el.offsetWidth / 2) + container.offsetWidth + 50 < window.innerWidth ? 
                      (el.offsetLeft + el.offsetParent.offsetLeft + (el.offsetWidth / 2)).toString() + 'px' : (window.innerWidth - container.offsetWidth - 60).toString() + 'px');
      }
      
  }
  

  static void _leave(Event e) {
          querySelector('#tooltips').style.display = 'none'; 
  }


}