library field;

import 'dart:html';


class ShuttleField {
    
    
  //
  // Static

  static void initialize() {
    querySelector('body')
        ..onMouseDown.listen(click)
        ..onKeyDown.listen(keydown)
        ..onBlur.listen(blur);
  }

  
  // Clicking a shuttlefield that is an input box will
  // select all the text
  static void click(Event e) {
    if (isCompatible(e)) {
      e.preventDefault();
      new ShuttleField(e.target)
        .._click();
    }
  }

  
  static void keydown(Event e) {
      new ShuttleField(e.target)._keydown(e);
  }

  
  static void blur(Event e) {
      new ShuttleField(e.target)._keydown(e);

  }

  
  static bool isCompatible(Event e) {
    Element el = e.target;
    return el.classes.contains('shuttleField');
  }

  

  //
  // Instanced
  //

  Element element;
  String uuid;
  String field;

  // Need an element, which we will use attributes of to
  // get the uuid and field name from
  ShuttleField(Element el) {
    this.element = el;
    this.uuid = el.getAttribute("uuid");
    this.field = el.getAttribute("field");
  }


  // ShuttleFields can be spans or text inputs
  _click() {
    if (element is TextInputElement) {
    
        
        
        TextInputElement el = element;
      el.select();
    
    
    } else if (element is ButtonElement) {
      querySelector('body').insertAdjacentHtml('afterBegin', '<div class="shuttleField">TEXT TEST TEXT!</div>');
    } else {
      element.style.backgroundColor = 'red';
    }
  }


  _keydown(KeyboardEvent e) {
    print(" " + e.keyCode.toString() + " " + e.keyLocation.toString());
  }
  
  
  _disableTemporarily() {
      element.style.opacity = '0.5';
      element.style.pointerEvents = 'none';
      element.insertAdjacentElement('afterEnd', 
            new DivElement()
                ..classes.add('progress')
                ..style.position = 'absolute'
                ..style.left = element.offsetLeft.toString() 
                    + (element.offsetWidth / 2).toString() + 'px');
  }




}


